"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ArrayMember = void 0;
/* eslint-disable @typescript-eslint/ban-types */
const common_errors_1 = require("common-errors");
const storage_1 = require("../storage");
function ArrayMember(index, options) {
    if (typeof (index) !== 'number') {
        throw new common_errors_1.TypeError('index must be number');
    }
    return (target, propertyKey) => {
        const storage = (options === null || options === void 0 ? void 0 : options.arrayMemberStorage) || storage_1.defaultArrayMemberStorage;
        storage.add(target.constructor, index, new storage_1.PropertyInfo(propertyKey, options));
    };
}
exports.ArrayMember = ArrayMember;
//# sourceMappingURL=ArrayMember.js.map