import { ClassType } from 'class-transformer-validator';
import { ClassConstructor } from './interfaces/class-constructor.type';
import { ArrayStorageOptions, ClassToPlainArrayOptions, ClassTransformForArrayOptions, TransformValidationForArrayOptions } from './types';
export * from './decorators';
export * from './storage';
export * from './exceptions';
export * from './types';
export declare function plainMapValue<T>(target: ClassConstructor<T>, array: unknown[] | unknown[][], options?: ArrayStorageOptions): Record<string, unknown>;
export declare function plainArrayToClass<T>(target: ClassConstructor<T>, array: unknown[], options?: ClassTransformForArrayOptions & {
    isArray?: false;
}): T;
export declare function plainArrayToClass<T>(target: ClassConstructor<T>, array: unknown[][], options?: ClassTransformForArrayOptions & {
    isArray: true;
}): T[];
export declare function classMapValue<T>(target: ClassConstructor<T>, object: Record<string, unknown>, options?: ArrayStorageOptions): unknown[];
export declare function classToPlainArray<T>(object: T, options?: ClassToPlainArrayOptions): unknown[];
export declare function classToPlainArray<T>(object: T[], options?: ClassToPlainArrayOptions): unknown[][];
export declare function arrayTransformAndValidate<T extends object>(target: ClassType<T>, array: unknown[], options?: TransformValidationForArrayOptions & {
    isArray?: false;
}): Promise<T>;
export declare function arrayTransformAndValidate<T extends object>(target: ClassType<T>, array: unknown[][], options?: TransformValidationForArrayOptions & {
    isArray: true;
}): Promise<T[]>;
//# sourceMappingURL=index.d.ts.map